!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
subroutine lasso(sol,step,stepmax,df)      !!!!!!sol:ALASSO solution at transition points; step: the total iterative number; df: the number of non-zero coef in the sol; stepmax: the total maximum iterative number (in case that cannot stop in some worst situation that the distribution is skewed and parameters are estimated from samll m_0 reference sample)
use imsl
use datax
integer mvj,flag,seta(pp),sa,setb(pp),jhat,mvjc,step,sat,mm,stepmax,df(stepmax)
real*8 corr(pp),pbeta(pp),sig2(nn,pp),l1(pp),aa,sig3(pp,pp),wa(pp),ua(nn),a1(pp),cest,ra(pp),d(pp),sgna(pp),eps(nn),pbeta1(pp),sol(stepmax,pp),rtemp(pp),setbtemp(pp)
real*8 rest,minrtemp,minr,g1(pp,pp),g2(pp,pp),v(pp)
real*8 cs(pp),sn(pp)
real*8 q1,q2
real*8 lam
real*8 sgn
logical pivot
integer ipvtn(pp)
sol=0.0d0
flag=0
pbeta=0.0d0
seta=0
setb=0
l1=1.0d0
sig2=0.0d0
mm=0
rest=1.0d0
df=0.0d0
40 format(4f15.3)
sa=1
sat=0
corr=0.0d0
a1=0.0d0
pbeta1=((.i.((.t.xx).x.xx)).x.(.t.xx).x.yy)
do while(flag==0.and.mm<stepmax)
 mm=mm+1
 df(mm)=dble(sa)
 if(sa>sat) then
  corr=(.t.xx).x.(yy-(xx.x.pbeta))
  mvj=maxloc(abs(corr),dim=1)
  cest=maxval(abs(corr))
  sgna=0.0d0
  if(mm==1) then
   seta(mvj)=1
   setb(mm)=mvj
  endif
  sa=sum(seta)
  sat=sa
   i=0
   do while(i<pp)
    i=i+1
	if(seta(i)/=0) sgna(i)=sgn(corr(i))
   enddo

   do i=1,sa
     sig2(:,i)=sgna(setb(i))*xx(:,setb(i))
   enddo
  v=0.0d0
  v(1:sa-1)=(.t.sig2(:,2:sa)).x.sig2(:,1)
   if(mm==1) then
     g2=0.0d0
	 g1=0.0d0
     g2(1,1)=sum(sig2(:,1)*sig2(:,1))**0.5
	 g1(1,1)=sum(sig2(:,1)*sig2(:,1))**0.5
   else
	 call dldnch(sa-1,g1(1:sa-1,1:sa-1),sa-1,v(1:sa-1)/sum(sig2(:,1)*sig2(:,1))**0.5,g1(1:sa-1,1:sa-1),sa-1,cs(1:sa-1),sn(1:sa-1))
     call erset(0,0,0)
	 g2=0.0d0
     g2(1,1)=sum(sig2(:,1)*sig2(:,1))**0.5
     g2(1,2:sa)=v/sum(sig2(:,1)*sig2(:,1))**0.5
     g2(2:sa,2:sa)=g1(1:sa,1:sa)
     g1(1:sa,1:sa)=g2(1:sa,1:sa)
   endif
  call dlinrt(sa,g2(1:sa,1:sa),sa,2,sig3(1:sa,1:sa),sa)
  sig3(1:sa,1:sa)=sig3(1:sa,1:sa).x.(.t.sig3(1:sa,1:sa))
  aa=dblinf(sa,sa,sig3(1:sa,1:sa),sa,l1(1:sa),l1(1:sa))**(-0.5d0)
  wa=aa*(sig3(1:sa,1:sa).x.l1(1:sa))
  ua=sig2(:,1:sa).x.wa
  a1=(.t.xx).x.ua
  d=0.0d0
   do i=1,sa
    d(setb(i))=sgna(setb(i))*wa(i)
   enddo
   setbtemp=setb
   i=0
   j=0
  do while(i<pp)
     i=i+1
	 if(seta(i)==0) then
	   j=j+1
	  
	   if(j==1) then
	    minrtemp=pmin((cest-corr(i))/(aa-a1(i)),(cest+corr(i))/(aa+a1(i)))
	    mvjc=i
	   endif
       rest=pmin((cest-corr(i))/(aa-a1(i)),(cest+corr(i))/(aa+a1(i)))
	   if(rest<minrtemp) then
	    minrtemp=rest
		mvjc=i
       endif
     endif
   enddo 
   rest=minrtemp
 ra=0.0d0
 do i=1,sa
  ra(i)=-pbeta(setb(i))/d(setb(i))
 enddo
 if(sa==pp) then
  do i=1,pp
   rtemp(i)=(pbeta1(i)-pbeta(i))/d(i)
  enddo
   rest=minval(rtemp,mask=rtemp>1.0e-15)
 endif

if(rest>=1000.0) then
 pbeta=pbeta1
 flag=1
else
 if(maxval(ra)>1.0e-15) then
  minr=minval(ra,mask=ra>1.0e-15)
 else
  minr=100000.0d0
 endif
   if(minr<rest) then
     jhat=setb(minloc(ra,dim=1,mask=ra>1.0e-15))
     pbeta=pbeta+(minr*d)
     seta(jhat)=0
    do i=1,sa
      if(setb(i)==jhat) then
	   setb(i:sa-1)=setbtemp(i+1:sa)
	   setb(sa)=0
      endif
	enddo
   else
    if(sa<pp) then
     seta(mvjc)=1
	 setb(1)=mvjc
     do i=2,sa+1
      setb(i)=setbtemp(i-1)
	 enddo
     pbeta=pbeta+(rest*d)
    endif
   endif
  if(mm>=pp.and.rest<minr.and.sa==pp) then
   pbeta=pbeta+(rest*d)
   flag=1
   endif
  sa=sum(seta)
 endif
else
  corr=(.t.xx).x.(yy-(xx.x.pbeta))
  mvj=maxloc(abs(corr),dim=1)
  cest=maxval(abs(corr))
  sgna=0.0d0
  if(mm==1) then
   seta(mvj)=1
   setb(mm)=mvj
  endif
  sa=sum(seta)
  sat=sa
   i=0
   do while(i<pp)
     i=i+1
	 if(seta(i)/=0) sgna(i)=sgn(corr(i))
   enddo
   do i=1,sa
     sig2(:,i)=sgna(setb(i))*xx(:,setb(i))
   enddo
  call dlchrg(sa,((.t.sig2(:,1:sa)).x.sig2(:,1:sa)),sa,pivot,ipvtn(1:sa),g1(1:sa,1:sa),sa)
  call dlinrt(sa,g1(1:sa,1:sa),sa,2,sig3(1:sa,1:sa),sa)
  sig3(1:sa,1:sa)=sig3(1:sa,1:sa).x.(.t.sig3(1:sa,1:sa))
  aa=dblinf(sa,sa,sig3(1:sa,1:sa),sa,l1(1:sa),l1(1:sa))**(-0.5d0)
  wa=aa*(sig3(1:sa,1:sa).x.l1(1:sa))
  ua=sig2(:,1:sa).x.wa
  a1=(.t.xx).x.ua
  d=0.0d0
   do i=1,sa
    d(setb(i))=sgna(setb(i))*wa(i)
   enddo
   setbtemp=setb
   i=0
   j=0
  do while(i<pp)
     i=i+1
	 if(seta(i)==0) then
	   j=j+1
	   if(j==1) then
	    minrtemp=pmin((cest-corr(i))/(aa-a1(i)),(cest+corr(i))/(aa+a1(i)))
	    mvjc=i
	   endif
       rest=pmin((cest-corr(i))/(aa-a1(i)),(cest+corr(i))/(aa+a1(i)))
	   if(rest<minrtemp) then
	    minrtemp=rest
		mvjc=i
       endif
     endif
   enddo 
    rest=minrtemp
  ra=0.0d0
  do i=1,sa
   ra(i)=-pbeta(setb(i))/d(setb(i))
  enddo
  if(sa==pp) then
   do i=1,pp
    rtemp(i)=(pbeta1(i)-pbeta(i))/d(i)
   enddo
   rest=minval(rtemp,mask=rtemp>1.0e-15)
  endif
 if(rest>=1000.0) then
  pbeta=pbeta1
  flag=1
 else

  if(maxval(ra)>1.0e-15) then
   minr=minval(ra,mask=ra>1.0e-15)
  else
   minr=100000.0d0
  endif
  if(minr<rest) then
     jhat=setb(minloc(ra,dim=1,mask=ra>1.0e-15))
     pbeta=pbeta+(minr*d)
     seta(jhat)=0
    do i=1,sa
      if(setb(i)==jhat) then
	   setb(i:sa-1)=setbtemp(i+1:sa)
	   setb(sa)=0
      endif
	enddo
   else
    if(sa<pp) then
     seta(mvjc)=1
	 setb(1)=mvjc
     do i=2,sa+1
      setb(i)=setbtemp(i-1)
	 enddo
     pbeta=pbeta+(rest*d)
    endif
   endif
   if(mm>=pp.and.rest<minr.and.sa==pp) then
    pbeta=pbeta+(rest*d)
    flag=1
   endif
  sa=sum(seta)
  endif
 endif
 sol(mm,:)=pbeta
 enddo
step=mm
end subroutine lasso
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
real*8 function pmin(x,y)
real*8 x,y
if(min(x,y)>0.0) then
 pmin=min(x,y)
else
 if(max(x,y)>0.0) then
  pmin=max(x,y)
 else
  pmin=1000.0d0
 endif
endif
return
end function pmin
!!!!!!!!!!!!!!!!!!!!!
real*8 function sgn(x)
real*8 x
 if(x>0.0d0) sgn=1.0d0
 if(x<0.0d0) sgn=-1.0d0
 if(x==0.0d0) sgn=0.0d0
return
end function sgn
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
real*8 function tr(n,x)
integer n
real*8 x(n,n),temp
 temp=0.0d0
 do i=1,n
  temp=temp+x(i,i)
 enddo
 tr=temp
return
end function tr
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!compute_mean&variance of p alasso solution to calulated the standardized lasso testing statistics.
subroutine lasso_com_mu(ind,n,p,pho,expe,std)                       !!!!!!!!!!!ind: the index indicating which type of lasso used. 1: the usual lasso; 2: adaptive lasso with r=0.5; 3: r=1; r=2
use imsl
use datax
integer n,p,i,j,ns,iseed,n1,p1,step,irank,stepmax,ind
parameter(ns=100000,iseed=1235623,stepmax=25)
integer df(stepmax)
real*8 y,h,sig1(p,p),id(p,p),x,sig(p,p),rsig(p,p),sol(p,p),sol1(stepmax,p),mu(p),pho(p,p),sol0(p,p)
real*8 mylamda(8)
real*8 yvec(n,p),delta1,delta2,delta3,delta4,r
real*8 yr(p),xtemp(p,p),ytemp(p),sig0(p,p),pbeta1(p),temp(p),lamt(p),lamn(2*stepmax),gtemp(p)
real*8 err,medi(ns)
real*8 bic(0:stepmax),pbeta(p),alpha(p),alphas(p),alpha0,vars(p),ttemp(2*p)
real*8 expe(p),std(p)
real*8 lam
target n1
target p1
target xtemp
target ytemp
nn=>n1
pp=>p1
xx=>xtemp
yy=>ytemp
n1=p
p1=p
 select case(ind)
  case(1)
   r=0
  case(2)
   r=0.5
  case(3)
   r=1.0
  case(4)
   r=2.0
 end select
  alpha0=0.05
  40 format(5f15.3)
  50 format(1f15.3)
  sig=.i.pho
  call marsqrt(p,sig,sig1)  
  call dchfac(p,pho,p,0.00001d0,irank,RSIG,p)
  alphas=0.0d0
  alpha=0.0d0
  sol=0.0d0
  df=0.0d0
  arl=0.0d0
  vars=0.0d0
  do ii=1,ns
    call rnset(iseed+1000*ii)
	call drnmvn(n,p,rsig,p,yvec,n)
    temp=0.0d0
	yvec(:,1)=yvec(:,1)+0.0d0
	do i=1,n
     temp=temp+yvec(i,:)
    enddo
    yr=temp/dble(n)
    pbeta1=yr
    ytemp=sig1.x.yr
	do j=1,p
	  xtemp(:,j)=sig1(:,j)*(abs(pbeta1(j))**r)   !!!!!!!!!!!!!!!!!!!!! adaptive lasso with r=1
	enddo
    call lasso(sol1(1:stepmax,:),step,stepmax,df)
    !if(step>p) write(*,*)ii,step
	j=p
	do i=step,1,-1
     if(df(i)==j)  then
	   sol(j,:)=sol1(i,:)
	   j=j-1
	 endif
    enddo
      do j=1,p
       sol(:,j)=sol(:,j)*(abs(pbeta1(j))**r)
      enddo
    do j=1,p
     mu=sol(j,:)
     tempmax=1.0*n*dblinf(p,p,sig,p,mu,yr)**2.0/dblinf(p,p,sig,p,mu,mu)
     alpha(j)=tempmax
    enddo
    alphas=alphas+alpha
    vars=vars+(alpha(:)*alpha(:))
  enddo
   expe=alphas/dble(ns)
   std=((vars-1.0*ns*(alphas/dble(ns))**2.0)/dble(ns))**0.5 
   !write(*,40)alphas/dble(nns),((vars-1.0*nns*(alphas/dble(nns))**2.0)/dble(nns))**0.5
end subroutine lasso_com_mu